<?php

class Model_eco1 extends CI_Model {
	
	function eco1_userCheck($user) {
		$this->db->select('*');
        $this->db->where('user', $user);
        $query = $this->db->get("eco1_users");
        if ($query->num_rows > 0) {
            $result = $query->first_row();
			return 1;
		}
        return 0;
	}
	function eco1_userAdd($user, $pass) {
		//INSERT NEW TABLE
		$query_newTable =
			"CREATE TABLE IF NOT EXISTS `eco1__<usertable>` (
			  `id` INT NOT NULL AUTO_INCREMENT ,
			  PRIMARY KEY (`id`) )
			ENGINE = InnoDB";
		$query = preg_replace('/<usertable>/i', $user, $query_newTable);
		$ret = $this->db->query($query);
		
		//INSERT USER
		$dt = date("Y-m-d H:i:s"); // YYYY-MM-DD HH:MM:SS (the MySQL DATETIME format)
        $data = array (
          'user'		=> $user,
          'pass'  		=> $pass,
          'table'      	=> "eco1__" . $user,
          'creation'    => $dt,
          'access'      => $dt,
        );
        $this->db->insert("eco1_users", $data);
		return 0;
	}
	function eco1_userPassCheck($user, $pass) {
		$this->db->select('*');
        $this->db->where('user', $user);
        $this->db->where('pass', $pass);
        $query = $this->db->get("eco1_users");
        if ($query->num_rows > 0) {
            $result = $query->first_row();
			return 0;
		}
        return 1;
	}
	function eco1_userDump($user, $pass) {
		if($this->eco1_userPassCheck($user, $pass)) {
			return 0;
		}
		$this->db->select('*');
		$userDb = "eco1__" . $user;
        $query = $this->db->get($userDb);
		return $query;
	}
	function eco1_userEdit($user, $pass) {
		if($this->eco1_userPassCheck($user, $pass)) {
			return 0;
		}
		$this->db->select('*');
		$this->db->limit(1);
		$userDb = "eco1__" . $user;
        $query = $this->db->get($userDb);
        return $query;
	}
	
	function eco1_table_addColumn($user, $pass, $col, $type) {
		if($this->eco1_userPassCheck($user, $pass)) {
			return 0;
		}
		$this->load->dbforge();
		$userDb = "eco1__" . $user;
		if ($type == "int") {
			$fields = array(
				$col => array('type' => 'INT(11)')
			);
		}
		else if ($type == "varchar") {
			$fields = array(
				$col => array('type' => 'VARCHAR(100)')
			);
		}
		else if ($type == "datetime") {
			$fields = array(
				$col => array('type' => 'DATETIME')
			);
		}
		$this->dbforge->add_column($userDb, $fields);
	}		 
	function eco1_table_delColumn($user, $pass, $col) {
		if($this->eco1_userPassCheck($user, $pass)) {
			return 0;
		}
		$this->load->dbforge();
		$userDb = "eco1__" . $user;
		$this->dbforge->drop_column($userDb, $col);
	}
	
	//PUT-----
	function eco1_table_put($user, $pass, $data) {
		if($this->eco1_userPassCheck($user, $pass)) {
			return 0;
		}
		$userDb = "eco1__" . $user;
//CHECK IF INSERT FAILS?
        return $this->db->insert($userDb, $data);
	}
	
	//GET-----
	function eco1_table_get($user, $pass, $data) {
		if($this->eco1_userPassCheck($user, $pass)) {
			return 0;
		}
		
		foreach ($data as $arrayType => $array) {
			if ($arrayType == "limit")
				foreach ($array as $key => $val)
					foreach ($val as $key1 => $val1) $this->db->limit($key1, $val1);
			else if ($arrayType == "order")
				foreach ($array as $key => $val)
					foreach ($val as $key1 => $val1) $this->db->order_by($key1, $val1);
			else if ($arrayType == "field")
				foreach ($array as $key => $val)
					foreach ($val as $key1 => $val1) $this->db->where($key1, $val1);
		}
		
		$userDb = "eco1__" . $user;
//CHECK IF GET FAILS?
		$query = $this->db->get($userDb);
        return $query->result();
	}
	
	//DELETE-----
	function eco1_table_delete($user, $pass, $data) {
		if($this->eco1_userPassCheck($user, $pass)) {
			return 0;
		}
		foreach ($data as $key => $val) $this->db->where($key, $val);
		$userDb = "eco1__" . $user;
//CHECK IF DELETE FAILS?
        return $this->db->delete($userDb, $data);
	}
}